 LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system 

;======================================================================
;Program: Resetator pres SMS, verze pro Vyhlidku
;Telefon: Siemens C35
;Popis: 2 nezavisle vystupy, sepnou se na 3sec po prichodu "dobre" SMS
;Mod: Umi zapinat telefon, umi resetovat, kdyz phone umre
;======================================================================

 #include "P16F628.INC"  ; Include header file 



; Verze 1: tohle je config pro zapojeni s krystalem a s externim MCRL
; __config  _XT_OSC &_LVP_OFF & _WDT_ON & _PWRTE_ON & _BODEN_OFF 

; Verze 2: tohle by mel byt config pro zapojeni bez krystalu a bez externiho MCLR 
 __config  _INTRC_OSC_NOCLKOUT &_LVP_OFF & _WDT_ON & _PWRTE_ON & _BODEN_OFF & _MCLRE_OFF 



; definice konstatnt
 constant ENTER=0DH
 constant noanswers=30   ;pocet cyklu, kdy telefon neodpovi -> asi zdechnul

; definice promennych
pocet       equ 20H
;rings       equ 22H
flags1      equ 23H
pozice      equ 24H
tmp         equ 25H
tmp_1       equ 26H
cas0        equ 27H
cas1        equ 28H
cas2        equ 29H
pamet_1     equ 30H
pamet_2     equ 31H
pamet_3     equ 32H
pamet_4     equ 33H
pamet_5     equ 34H
pamet_6     equ 35H
pamet_7     equ 36H
pamet_8     equ 37H
pamet_9     equ 38H
pamet_10    equ 39H
pamet_11    equ 3AH
pamet_12    equ 3BH
TMPW        equ 3CH
TMPS        equ 3DH
cnt1        equ 3EH
cnt2        equ 3FH
swdt        equ 40H
; bity
spojeni_ok  equ 01H

; vystupy
relatko1    equ 04H
relatko2    equ 05H
led         equ 03H
led2        equ 02H
;zapnuti napajeni do mobilu    
napajeni    equ 07h
;zapnuti mobilu (negovane)
zap	        equ 06h
    


               ORG 0
               goto start


; Preruseni od seriove linky pouze pro test pripojeni mobilu -------------------
               ORG 4
               bcf STATUS,RP0     ;prijme znak z mobilu
               btfss RCSTA,OERR
               goto $+3
               bcf RCSTA,CREN
               bsf RCSTA,CREN
               movf RCREG,W
               movwf tmp          ;uloz znak do tempu
               bcf STATUS,Z
               movlw 'O'          ;testuj znak OK - tzn. pripojeni v poradku
               subwf tmp,w
               btfss STATUS,Z     ;shoda = ven
               retfie
               bsf flags1,spojeni_ok
               clrf swdt          ;smaze pocet neodpovedi telefonu
               retfie 


; Casovaci rutina 150 msec. ----------------------------------------------------
cekame         clrwdt
               movlw 0x0E5        ;229 DEC
               movwf cas1
               movlw 0x0D9        ;217 DEC
               movwf cas0
               decfsz cas0,F
               goto $-1
               decfsz cas1,F
               goto $-5
               return


; Casovaci rutina 1 sec. -------------------------------------------------------
cekame_1       clrwdt
               MOVLW 0x15         ;21 DEC
               MOVWF cas2
               MOVLW 0x59         ;89 DEC
               MOVWF cas1
               MOVLW 0x0B1        ;177 DEC
               MOVWF cas0
               DECFSZ cas0,F
               GOTO $-1
               DECFSZ cas1,F
               GOTO $-5
               DECFSZ cas2,F
               GOTO $-9
               return


; Nacte pocet znaku ze seriaku podle cisla v W, vysledek je ve W ---------------
orizni         movwf tmp_1
opak           call receive       ;nacti znak z MT
               decfsz tmp_1,f
               goto opak
               return


; Posle prikaz AT+ -------------------------------------------------------------
prikaz_AT      movlw 'A'
               call send
               movlw 'T'
               call send
               movlw '+'
               call send
               return


; Posle prikaz ATH a enter to je ZAVESIT ---------------------------------------
zavesit        movlw 'A'
               call send
               movlw 'T'
               call send
               movlw 'H'
               call send
               movlw ENTER
               call send
               return


; Nuluje RAM -------------------------------------------------------------------
null_ram       movlw 0FFH
               movwf pamet_1
               movwf pamet_2
               movwf pamet_3
               movwf pamet_4
               movwf pamet_5
               movwf pamet_6
               movwf pamet_7
               movwf pamet_8
               movwf pamet_9
               movwf pamet_10
               movwf pamet_11
               movwf pamet_12
               return


; Nacte znaky do RAM -----------------------------------------------------------
cti_znaky      call receive       ;cti 12znaku ze seriaku
               movwf pamet_1
               call receive
               movwf pamet_2
               call receive
               movwf pamet_3
               call receive
               movwf pamet_4
               call receive
               movwf pamet_5
               call receive
               movwf pamet_6
               call receive
               movwf pamet_7
               call receive
               movwf pamet_8
               call receive
               movwf pamet_9
               call receive
               movwf pamet_10
               call receive
               movwf pamet_11
               call receive
               movwf pamet_12
               return


; Vycteni telefonniho cisla ze seznamu MT na zahlade pozice -------------------- 
vycti_cislo    call prikaz_AT
               movlw 'C'
               call send
               movlw 'P'
               call send
               movlw 'B'
               call send
               movlw 'R'
               call send
               movlw '='
               call send
               movfw pozice
               call send
               movlw ENTER
               call send
               ; --- Cti data z MT ---
pokr_07        call receive       ;cti jeden znak
               bcf STATUS,Z
               sublw '"'          ;testuj dosazeni ASCII znaku uvozovek,pokud nejsou,cti znovu seriak
               btfss STATUS,Z
               goto pokr_07
               movlw 1H           ;prisly uvozovky,zacina tlf. cislo,zadej do W
               call orizni        ;precte znak + a zahodi ho,bude pridan pri volani cisla
               call cti_znaky     ;precte 12 znaku ze seriaku
               call cekame        ;odcasuje
               return


; Vytoci telefonni cislo -------------------------------------------------------
volej_cislo    movlw'A'
               call send
               movlw 'T'
               call send
               movlw 'D'
               call send
               movlw '+'
               call send
               ; --- Doplni prikaz tel. cislem ---
               movf pamet_1,w
               call send
               movf pamet_2,w
               call send
               movf pamet_3,w
               call send
               movf pamet_4,w
               call send
               movf pamet_5,w
               call send
               movf pamet_6,w
               call send
               movf pamet_7,w
               call send
               movf pamet_8,w
               call send
               movf pamet_9,w
               call send
               movf pamet_10,w
               call send
               movf pamet_11,w
               call send
               movf pamet_12,w
               call send
               movlw ';'
               call send
               movlw ENTER
               call send
               call cekame_1      ;sestavovani spojeni
               call cekame_1
               call cekame_1
               call cekame_1
               call cekame_1
               call cekame_1
               call cekame_1
               call cekame_1
               call cekame_1      ;zvoni,zvoni, casovaci rutiny
               call cekame_1
               call zavesit       ;zavesi
               call cekame_1      ;odcasuje
               call test_pripojeni
               return


; Prozvoneni prvniho cisla -----------------------------------------------------
prozvon1       call null_ram      ;nuluje RAM pro telefonni cislo
               movlw '1'          ;pozice v tel seznamu, ktery bude prozvanet
               movwf pozice       ;pro jistotu to cpu do promenne
               call vycti_cislo   ;vycteni tlf. cisla z mobilu
               call volej_cislo   ;vytoci tlf.cislo
               return

; Prozvoneni druheho cisla -----------------------------------------------------
prozvon2       call null_ram      ;nuluje RAM pro telefonni cislo
               movlw '2'          ;pozice v tel seznamu, ktery bude prozvanet
               movwf pozice       ;pro jistotu to cpu do promenn
               call vycti_cislo   ;vycteni tlf. cisla z mobilu
               call volej_cislo   ;vytoci tlf.cislo
               return


; ##############################################################################
; Zacatek programu a inicializace ----------------------------------------------
start          movlw 7
               movwf CMCON;       CMCON=7 set comparators off   
               bsf STATUS,RP0
	             movlw 0h
               movwf VRCON      
               bcf STATUS,RP0     ;switch to bank 0
               bcf STATUS,RP1
               movlw b'00000000'  ;kvuli prechodu do nabijeni je nejprve out linka  v L na cca 2 sec
               movwf PORTB
               call cekame_1      ;cekej sekundu
               call cekame_1      ;cekej sekundu
               movlw b'00000100'
               movwf PORTB
               bsf PORTA,led        ;LED zhasnuta
               bsf PORTA,led2       ;LED2 zhasnuta
               ; --- Nastaveni portu ---
               bsf STATUS,RP0     ;RAM PAGE 1
               bcf OPTION_REG, 7  ;enable internal pullups
               movlw b'11110011'  ;port RA3 a RA2 is OUT, to sou LEDky :)
               movwf TRISA        ;portA
               movlw b'00001011'  ;input is all, port B pins 2,4,5 and 6 are OUT 
               movwf TRISB        ;portB
              ; --- Nastaveni UART pro Siemens C35, 19200Bd, no parity, 1 stopbit ---
               movlw 0x0C         ;0x0C=19200 bps
               movwf SPBRG        
               movlw b'00100100'  ;brgh = high (2)
               movwf TXSTA        ;enable Async Transmission, set brgh
               ; --- Nastaveni watchdogu ---
               bsf OPTION_REG,PS0 ;preddelicka 1:128
               bsf OPTION_REG,PS1
               bsf OPTION_REG,PS2
               bsf OPTION_REG,PSA ;preddelicka watchdog
               bcf STATUS,RP0     ;switch to bank 0
            
               movlw b'10010000'  ;enable Async Reception
               movwf RCSTA
               ; --- Pro jistotu vypne rele ---
               bcf PORTB,relatko1 ;odepne rele => pripoji elektriku
               bcf PORTB,relatko2 ;odepne rele => pripoji elektriku
               ; --- zapnuti telefonu ---
               bsf PORTB,zap      ;nastavi zapinaci signal do off 
               bcf PORTB,napajeni ;vypne napajeni telefonu (po resetu, jistota)
               call cekame_1      ;da mu 2 sekundy
               call cekame_1
               bsf PORTB,napajeni ;pusti stavu do telefonu
               call cekame_1      ;da mu 2 sekundy
               call cekame_1
               bcf PORTB,zap      ;pusti zapinaci signal
               call cekame_1      ;da mu 2 sekundy
               call cekame_1
               bsf PORTB,zap      ;nastavi zapinaci signal do off 
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      
               call cekame_1      ;telefon by mel byt zapnuty....


; Zakladni smycka --------------------------------------------------------------
zacatek        bcf STATUS,RP0     ;switch to bank 0
               call null_ram      ;nuluj RAM
               bsf PORTA,led      ;zhasni LED
               call test_pripojeni ;testuje pripojeni MT
               call cekame_1      ;perioda testu prichozich SMS
               call cekame_1
               call cekame_1
               bcf PORTA,led      ;rozsvit LED
               call cekame_1
               ; --- Test prichodu dove SMS ---
               call prikaz_AT     ;vysli prikaz AT+
               movlw 'C'
               call send
               movlw 'M'
               call send
               movlw 'G'
               call send
               movlw 'L'
               call send
               movlw '='
               call send
               movlw '0'
               call send
               movlw ENTER
               call send          ;vypise prijate neprectene zpravy
pokr_06        call receive       ;prijme znak z mobilu
               movwf tmp          ;uloz znak do tempu
               bcf STATUS,Z
               movlw 'O'          ;testuj znak OK - tzn. neni nova SMS
               subwf tmp,w
               btfsc STATUS,Z     ;je znak O, volej rutinu smazani aktualni SMS
               goto zacatek_exit  ;pokud je O, volej smazani SMS, kick out
               movlw ':'          ;testuj dosazeni dvojtecky
               subwf tmp,w
               btfss STATUS,Z
               goto pokr_06       ;dvojtecka neni.opakuj
               movlw 42H          ;nacti do W pocet ctenych byte z MT
               call orizni        ;zahodi 66 byte ze seriaku a tim jsem na zacatku platnych dat sms  ?? mozna min, TEST!!
               call cti_znaky     ;precte a ulozi 12 byte ze seriaku POZOR,pokud se meni sms pro ovladani,musi se zmenit i toto cislo
               ; --- Porovnavani prvni SMS F2 BC 4C 87 C5 00 jako Reset01---
prvni_sms      movlw 'F'          ;6 se ulozi se do W
               bcf STATUS,Z       ;smaze se Z
               subwf pamet_1,w    ;odecte se promenna pamet_1 od W
               btfss STATUS,Z     ;pokud se znak rovna, preskoci na test nalsiho znaku
               goto druha_sms     ;test na druhe zpravy
               movlw '2'          ;9
               bcf STATUS,Z
               subwf pamet_2,w
               btfss STATUS,Z
               goto druha_sms
               movlw 'B'          ;B
               bcf STATUS,Z
               subwf pamet_3,w
               btfss STATUS,Z
               goto druha_sms
               movlw 'C'          ;3
               bcf STATUS,Z
               subwf pamet_4,w               
               btfss STATUS,Z
               goto druha_sms
               movlw '4'          ;A
               bcf STATUS,Z
               subwf pamet_5,w
               btfss STATUS,Z
               goto druha_sms
               movlw 'C'          ;5
               bcf STATUS,Z
               subwf pamet_6,w
               btfss STATUS,Z
               goto druha_sms
               movlw '8'          ;0
               bcf STATUS,Z
               subwf pamet_7,w
               btfss STATUS,Z
               goto druha_sms
               movlw '7'          ;D
               bcf STATUS,Z
               subwf pamet_8,w
               btfss STATUS,Z
               goto druha_sms
               movlw 'C'          ;4
               bcf STATUS,Z
               subwf pamet_9,w
               btfss STATUS,Z
               goto druha_sms
               movlw '5'          ;2
               bcf STATUS,Z
               subwf pamet_10,w
               btfss STATUS,Z
               goto druha_sms
               movlw '0'          ;0
               bcf STATUS,Z
               subwf pamet_11,w
               btfss STATUS,Z
               goto druha_sms
               movlw '0'          ;1     
               bcf STATUS,Z
               subwf pamet_12,w
               btfss STATUS,Z
               goto druha_sms
               ; --- Prvni SMS vyhovela, provede akce ---
               call rele1         ;zavole rutinu pro flash rele1
               goto zacatek          ;ukonceni hlavni smycky
               ; --- Porovnavani druhe SMS F2 BC 4C 87 C9 00 jako Reset02---
druha_sms      movlw 'F'          ;6 se ulozi se do W
               bcf STATUS,Z       ;smaze se Z
               subwf pamet_1,w    ;odecte se promenna pamet_1 od W
               btfss STATUS,Z     ;pokud se znak rovna, preskoci na test nalsiho znaku
               goto zacatek_exit  ;konec
               movlw '2'          ;9
               bcf STATUS,Z
               subwf pamet_2,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw 'B'          ;B
               bcf STATUS,Z
               subwf pamet_3,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw 'C'          ;3
               bcf STATUS,Z
               subwf pamet_4,w               
               btfss STATUS,Z
               goto zacatek_exit
               movlw '4'          ;A
               bcf STATUS,Z
               subwf pamet_5,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw 'C'          ;5
               bcf STATUS,Z
               subwf pamet_6,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw '8'          ;0
               bcf STATUS,Z
               subwf pamet_7,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw '7'          ;D
               bcf STATUS,Z
               subwf pamet_8,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw 'C'          ;4
               bcf STATUS,Z
               subwf pamet_9,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw '9'          ;2
               bcf STATUS,Z
               subwf pamet_10,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw '0'          ;0
               bcf STATUS,Z
               subwf pamet_11,w
               btfss STATUS,Z
               goto zacatek_exit
               movlw '0'          ;1     
               bcf STATUS,Z
               subwf pamet_12,w
               btfss STATUS,Z
               goto zacatek_exit
               ; --- Druha SMS vyhovela, provede akce ---
               call rele2         ;zavole rutinu pro flash rele1
               goto zacatek       ;ukonceni hlavni smycky
               ; --- Porovnavani treti SMS F2 BC 4C 87 CD 00 jako Reset3---
zacatek_exit   call smaz_sms      ;smaze vsechny SMS
               goto zacatek       ;vrati se na zacatek


; Provede sepnuti a odpojeni relatka 1 -----------------------------------------
rele1          bsf PORTB,relatko1 ;sepne rele => odpoji elektriku
               call smaz_sms      ;smaze vsechny sms
               call cekame_1      ;delay
               call cekame_1      ;delay
               call cekame_1      ;delay
               bcf PORTB,relatko1 ;odepne rele => pripoji elektriku
               call prozvon1      ;prozvoni prvni cislo
               call prozvon2      ;prozvoni druhe cislo
;               call prozvon3      ;prozvoni treti cislo
               return
        

; Provede sepnuti a odpojeni relatka 2 -----------------------------------------
rele2          bsf PORTB,relatko2 ;sepne rele => odpoji elektriku
               call smaz_sms      ;smaze vsechny sms, dostatecne trva
               call cekame_1      ;delay
               call cekame_1      ;delay
               call cekame_1      ;delay
               bcf PORTB,relatko2 ;odepne rele => pripoji elektriku
               call prozvon1      ;prozvoni prvni cislo
               call prozvon2      ;prozvoni druhe cislo
;               call prozvon3      ;prozvoni treti cislo
               return


; Smaze SMS, cislo v prikazu udava pozici zpravy, ktera ma byt smazana ---------
smaz_sms 
               call prikaz_AT      ;posli AT+
               movlw 'C'
               call send
               movlw 'M'
               call send
               movlw 'G'
               call send
               movlw 'D'
               call send
               movlw '='
               call send
               movlw '1'
               call send
               movlw ENTER
               call send
               call cekame
               call sms_loop

               call prikaz_AT      ;posli AT+
               movlw 'C'
               call send
               movlw 'M'
               call send
               movlw 'G'
               call send
               movlw 'D'
               call send
               movlw '='
               call send
               movlw '2'
               call send
               movlw ENTER
               call send
               call cekame
               call sms_loop

               call prikaz_AT      ;posli AT+
               movlw 'C'
               call send
               movlw 'M'
               call send
               movlw 'G'
               call send
               movlw 'D'
               call send
               movlw '='
               call send
               movlw '3'
               call send                
               movlw ENTER
               call send
               call cekame
               call sms_loop

               call test_pripojeni
               return

;               return
sms_loop       call receive         ;prijma znak tak dlouho, dokud neco neprijde
               movwf tmp            ;uloz znak do tempu
               bcf STATUS,Z
               movlw 'O'            ;testuj znak OK, potvrzeni prikazu
               subwf tmp,w
               btfss STATUS,Z       ;je znak O, volej rutinu smazani aktualni SMS
               goto sms_loop        ;neni znak OK, znova prijem dalsiho
;               call test_pripojeni;
               call cekame
               call cekame
               return
                         


; Posila cyklicky dotaz do MT, dokud nedostane OK nejde ven --------------------
test_pripojeni clrwdt
              bcf flags1,spojeni_ok
              bsf STATUS,RP0      ;bank 1
              bsf PIE1,RCIE       ;povol INT od seriove linky
              bsf INTCON,PEIE
              bsf INTCON,GIE
              bcf STATUS,RP0
              movlw 'A'
              call send
              movlw 'T'
              call send
              movlw ENTER
              call send
              call cekame_1
              bcf PORTA,led       ;ledparada
              call cekame
              bsf PORTA,led
              call cekame
              bcf PORTA,led
              call cekame
              bsf PORTA,led
              incf swdt          ; inkrementuje pocet cyklu ne-odpovedi
              movlw noanswers    ; test dosazeni poctu neodpovedi konstante
              subwf swdt,w
              btfsc STATUS,Z
deadloop      goto deadloop       ; kousne PIC, WDT za 2.3 sec resetne and go..      
              call cekame        ; konec ledparady
              btfss flags1,spojeni_ok  ;nastavovan v INT
              goto test_pripojeni
              bsf STATUS,RP0      ;bank 1
              bsf INTCON,GIE
              bsf INTCON,PEIE
              bcf PIE1,RCIE       ;zakaz INT od seriove linky
              bcf STATUS,RP0
              return


; Prijime znak z RS232 a ulozi jej do W ----------------------------------------
receive       movlw 0FFH          ;255
              movwf cnt1          ;do cnt1, dolni byte pomocneho timeru
              movwf cnt2          ;do cnt2, horni byte pomocenho timeru
              clrwdt              ;smaze watchdog
              bcf STATUS,RP0
              btfss RCSTA,OERR
              goto $+3
              bcf RCSTA,CREN
              bsf RCSTA,CREN
rec_loop      btfss PIR1,RCIF
              goto rec_loop1      ;znak neprisel -> skok na rec_loop1
              movf RCREG,W
              return
rec_loop1     call rec_loop2      ;bud resetne wdt nebo nic
              goto rec_loop
rec_loop2     bcf STATUS,Z        ;smaze zero bit
              movlw 0H            ;ulozi 0 do W
              subwf cnt2,w        ;odecte cnt2 od W -> W
              btfsc STATUS,Z      ;neni-li vysledek nula, preskoc nasl. instr.
              return              ;navrat
		          decfsz cnt1,f       ;dekrementuje cnt1 + podminka na nulu
		          goto rec_loopDD     ;cnt1<>0
		          movlw 0FFh          ;cnt1=0, 255 -> W
              movwf cnt1          ;W->cnt1
		          decfsz cnt2,f       ;dekrementuje cnt2 + podminka na nulu
              goto rec_loopDD     ;cnt2<>0, skok na rec_loopDD
              return              ;cnt2=0, navrat
rec_loopDD    clrwdt              ;smazani wdt
              return              ;navrat

; ------------------------------------------------------------------------------
; Posle znak z W pres RS232 a ceka dokud nebude odeslani dokonceno
send          clrwdt
              movwf TXREG         ;send data in W 
TransWt       bsf STATUS,RP0      ;RAM PAGE 1
WtHere        btfss TXSTA,TRMT    ;(1) transmission is complete if hi
              goto WtHere
              bcf STATUS,RP0      ;RAM PAGE 0
              return




 END






; Poznamky ke kodum
; Reset01
; _1,0,,28_0 7912460800 06518240C9 1246080337 7620000402 0405163310 007   D2 F2BC4C87C500

; Reset02
; _1,0,,28_0 7912460800 06518240C9 1246080337 7620000402 0405163310 007   D2 F2BC4C87C900

; Reset03
; _1,0,,28_0 7912460800 06518240C9 1246080337 7620000402 0405163310 007   D2 F2BC4C87CD00


